## net.sf.saxon.event
Class NamespaceReducer

    java.lang.Object
      |
      +--net.sf.saxon.event.ProxyReceiver
            |
            +--net.sf.saxon.event.NamespaceReducer

All Implemented Interfaces:
  Receiver, javax.xml.transform.Result

public class NamespaceReducer
extends ProxyReceiver

NamespaceReducer is a ProxyReceiver responsible for removing duplicate namespace declarations. It also ensures that an xmlns="" undeclaration is output when necessary. Used on its own, the NamespaceReducer simply eliminates unwanted namespace declarations. It can also be subclassed, in which case the subclass can use the services of the NamespaceReducer to resolve QNames.

The NamespaceReducer also validates namespace-sensitive content.

Field Summary

Fields inherited from class net.sf.saxon.event.ProxyReceiver
`baseReceiver, config, locationProvider, systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`NamespaceReducer()`

Method Summary
`void` `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Handle an attribute
`void` `endElement()` endElement: Discard the namespaces declared on this element.
`protected int` `getURICode(short prefixCode)` Get the URI code corresponding to a given prefix code, by searching the in-scope namespaces.
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `setConfiguration(Configuration config)` Set the name pool to be used for all name codes
`void` `startContent()` startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` startElement.

Methods inherited from class net.sf.saxon.event.ProxyReceiver
`characters, close, comment, endDocument, getConfiguration, getDocumentLocator, getNamePool, getSystemId, getUnderlyingReceiver, open, processingInstruction, setDocumentLocator, setSystemId, setUnderlyingReceiver, setUnparsedEntity, startDocument`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NamespaceReducer

    public NamespaceReducer()

Method Detail

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the name pool to be used for all name codes

  Specified by:
    `setConfiguration` in interface `Receiver`
  Overrides:
    `setConfiguration` in class `ProxyReceiver`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  startElement. This call removes redundant namespace declarations, and possibly adds an xmlns="" undeclaration.

  Specified by:
    `startElement` in interface `Receiver`
  Overrides:
    `startElement` in class `ProxyReceiver`
  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Description copied from class: `ProxyReceiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Specified by:
    `namespace` in interface `Receiver`
  Overrides:
    `namespace` in class `ProxyReceiver`
  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Handle an attribute

  Specified by:
    `attribute` in interface `Receiver`
  Overrides:
    `attribute` in class `ProxyReceiver`
  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `properties` - Bit significant value. The following bits are defined:
    DISABLE_ESCAPING
  Disable escaping for this attribute
    NO_SPECIAL_CHARACTERS
  Attribute value contains no special characters
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements

  Specified by:
    `startContent` in interface `Receiver`
  Overrides:
    `startContent` in class `ProxyReceiver`
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  endElement: Discard the namespaces declared on this element.

  Specified by:
    `endElement` in interface `Receiver`
  Overrides:
    `endElement` in class `ProxyReceiver`
    `XPathException`

### getURICode

    protected int getURICode(short prefixCode)

  Get the URI code corresponding to a given prefix code, by searching the in-scope namespaces. This is a service provided to subclasses.

  Parameters:
    `prefixCode` - the 16-bit prefix code required
  Returns:
    the 16-bit URI code, or -1 if the prefix is not found